package cn.com.infosec.asn1;

import java.util.Enumeration;
import java.util.Vector;

public abstract class ASN1Sequence extends ASN1Object {
   private Vector seq;

   public ASN1Sequence() {
      ASN1Sequence var10000 = this;
      super();
      Vector var1;
      var1 = new Vector.<init>();
      var10000.seq = var1;
   }

   public static ASN1Sequence getInstance(Object obj) {
      if (obj != null && !(obj instanceof ASN1Sequence)) {
         throw new IllegalArgumentException("unknown object in getInstance: " + obj.getClass().getName());
      } else {
         return (ASN1Sequence)obj;
      }
   }

   public static ASN1Sequence getInstance(ASN1TaggedObject obj, boolean explicit) {
      if (explicit) {
         if (obj.isExplicit()) {
            return (ASN1Sequence)obj.getObject();
         } else {
            throw new IllegalArgumentException("object implicit - explicit expected.");
         }
      } else if (obj.isExplicit()) {
         return (ASN1Sequence)(obj instanceof BERTaggedObject ? new BERSequence(obj.getObject()) : new DERSequence(obj.getObject()));
      } else if (obj.getObject() instanceof ASN1Sequence) {
         return (ASN1Sequence)obj.getObject();
      } else {
         throw new IllegalArgumentException("unknown object in getInstance: " + obj.getClass().getName());
      }
   }

   public Enumeration getObjects() {
      return this.seq.elements();
   }

   public ASN1SequenceParser parser() {
      return new ASN1SequenceParser() {
         private final int max = ASN1Sequence.this.size();
         private int index;

         public DEREncodable readObject() {
            int var1;
            if ((var1 = this.index) == this.max) {
               return null;
            } else {
               ASN1Sequence var10000 = ASN1Sequence.this;
               this.index = var1 + 1;
               DEREncodable var2;
               if ((var2 = var10000.getObjectAt(var1)) instanceof ASN1Sequence) {
                  return ((ASN1Sequence)var2).parser();
               } else {
                  return (DEREncodable)(var2 instanceof ASN1Set ? ((ASN1Set)var2).parser() : var2);
               }
            }
         }

         public DERObject getDERObject() {
            return ASN1Sequence.this;
         }
      };
   }

   public DEREncodable getObjectAt(int index) {
      return (DEREncodable)this.seq.elementAt(index);
   }

   public int size() {
      return this.seq.size();
   }

   public int hashCode() {
      Enumeration var3 = this.getObjects();
      int var1 = 0;

      while(var3.hasMoreElements()) {
         Object var2;
         if ((var2 = var3.nextElement()) != null) {
            var1 ^= var2.hashCode();
         }
      }

      return var1;
   }

   boolean asn1Equals(DERObject o) {
      if (!(o instanceof ASN1Sequence)) {
         return false;
      } else {
         ASN1Sequence o1 = (ASN1Sequence)o;
         if (this.size() != o1.size()) {
            return false;
         } else {
            Enumeration var4 = this.getObjects();
            Enumeration o2 = o1.getObjects();

            DERObject var2;
            DERObject var3;
            do {
               do {
                  if (!var4.hasMoreElements()) {
                     return true;
                  }
               } while((var2 = ((DEREncodable)var4.nextElement()).getDERObject()) == (var3 = ((DEREncodable)o2.nextElement()).getDERObject()));
            } while(var2 != null && var2.equals(var3));

            return false;
         }
      }
   }

   protected void addObject(DEREncodable obj) {
      this.seq.addElement(obj);
   }

   abstract void encode(DEROutputStream var1);

   public String toString() {
      return this.seq.toString();
   }
}
